#!/usr/local/bin/perl


=pod 
=head1 NAME

ComputeWindowStatistics.pl - This program computes characteristics about windows of the replicon of the organism

=head1  SYNOPSIS 

./ComputeWindowStatistics.pl --cfg $PeRNA/cfg/Conf.cfg --kingdom Bacteria --organism "Escherichia coli" --strain K12 --replicon chromosome --word_max_length 2 --win_min_length 70 --win_max_length 70 --step 10 --shift_size 1
./ComputeWindowStatistics.pl --cfg $PeRNA/cfg/Conf.cfg --kingdom Archea --organism "Methanococcus jannaschii" --strain DSM_2661 --replicon plasmid1 --word_max_length 2 --win_min_length 70 --win_max_length 70 --step 10 --shift_size 10


=head1 DESCRIPTION

ComputeWindowStatistics.pl computes characteristics about windows of the sequence of replicon
It compute windows of different size (win_min_length <= size <= win_max_length) (next size = size+step) and shift each window 
of shift_size nucleotids about the genomic sequence 
For each window, it computes characteristics: 
numbers of k-nucleotid (1<= k<= word_max_length) in the sequence,
numbers of k-nucleotid in the paired nucleotids,
free energy,
number of paired/unpaired nucleotids
number of each pair (A-U, U-A, G-C, C-G, G-U, U-G)
PeRNA bank is completed:
<replicon>
	basic_statistics
		win{length}_shift{size}_stat
			A_seq
			C_seq...
			AA_seq...
			A_struct...
			GC_pair...
			FreeEnergy
			PairInformation

=cut

BEGIN
{
	my ($dirprg, $nameprg) = $0 =~/(.+)\/(.+)/;
	push(@INC, "$dirprg/../lib");	# @INC contains the directory for perl libraries
}

use strict;
use warnings;
use LWP;


use ParamParser;
use Logger;
use ToolBox;
use Stat;
use DnaToolBox;

our $BASIC_STAT_DIR_NAME;
our $MULTI_FASTA_FILE_NAME;
our $FE_FILE_NAME;
our $PAIR_INFO_FILE_NAME;

MAIN:
{
	my $rh_param = New ParamParser('GETOPTLONG',("help:s", "cfg=s","kingdom=s", "organism=s", 
	"strain=s", "replicon=s", "word_max_length=i","win_min_length=i","win_max_length=i","step=i","shift_size=i"));
	$rh_param->SetUsage(my $usage=sub { &Usage(); } );
	$rh_param->AssertDefined(('cfg','kingdom', 'organism', 'strain', 'replicon', 
	'word_max_length','win_min_length','win_max_length','step','shift_size'));
	$rh_param->AssertFileExists('cfg');
	$rh_param->Update($rh_param->Get('cfg'),'A');

	# check that some parameters are integer
	$rh_param->AssertInteger('word_max_length');
	$rh_param->AssertInteger('win_min_length');
	$rh_param->AssertInteger('win_max_length');
	$rh_param->AssertInteger('step');
	$rh_param->AssertInteger('shift_size');
	
	my $kingdom  		= $rh_param->Get('kingdom');
	my $organism  		= $rh_param->Get('organism');
	my $strain  		= $rh_param->Get('strain');
	my $replicon  		= $rh_param->Get('replicon');
	my $word_max_length 	= $rh_param->Get('word_max_length');
	my $win_min_length  	= $rh_param->Get('win_min_length');
	my $win_max_length  	= $rh_param->Get('win_max_length');
	my $step  		= $rh_param->Get('step');
	my $shift_size 		= $rh_param->Get('shift_size');
	my $DATA_DIR   		= $rh_param->Get('DATA_DIR');
	$BASIC_STAT_DIR_NAME	= $rh_param->Get('BASIC_STAT_DIR_NAME');
	$MULTI_FASTA_FILE_NAME	= $rh_param->Get('MULTI_FASTA_FILE_NAME');
	$FE_FILE_NAME 		= $rh_param->Get('FE_FILE_NAME');
	$PAIR_INFO_FILE_NAME	= $rh_param->Get('PAIR_INFO_FILE_NAME');
	
	my $replicon_way 	= &GetRepliconDir($DATA_DIR, $kingdom, $organism, $strain,$replicon);

	# create directory which will contain the data about the windows
	&CreateBasicStatDirectory($replicon_way, $BASIC_STAT_DIR_NAME);

	my $seqobj 	= &GetGenomicSequenceObject($replicon_way); 	# sequence object
	my $seq    	= $seqobj->seq();				# genomic sequence
	my $seq_length	= $seqobj->length();				# length of the genomic sequence
					
	my $last_begin;		# last window position to compute the windows
	my $subseq;		# subsequence of the genomic sequence corresponding at the window
	my $rh_file_desc; 	# ref about an hashtab composed of file descriptors
	my $win_dir_way;
	
	# compute characteristics for each window size 
	for (my $win_length = $win_min_length ; $win_length <= $win_max_length ; $win_length+= $step) {	
		print "Compute windows with length = $win_length ...\n";
	
		# create the directory for the window 
		&CreateWinDirectory($replicon_way, $win_length, $shift_size);
		$win_dir_way	= &GetWinDirWay($replicon_way, $win_length, $shift_size);
		# create the empty statistics files for the window size
		$rh_file_desc 	= &CreateStatEmptyFiles($win_dir_way, $win_length, $word_max_length);
		$last_begin 	= $seq_length - $win_length;	

		# for each shift of the window about the genomic sequence
		for (my $begin = 0 ; $begin <= $last_begin ; $begin+=$shift_size) {
			$subseq = substr($seq, $begin, $win_length);
		
			# compute characteristics about this window
			&ComputeAShiftStat($subseq, $word_max_length, $win_dir_way, $win_length, $rh_file_desc);
		}
		# delete the file rna.ps generated by RNAfold in the directory of this window
		&DeleteFile($win_dir_way."rna.ps");
	}

}

=head1 SUBROUTINES

=cut

sub Usage
{
print STDERR<<END
Usage:
$0	
		--help		: this message
		--cfg		: the configuration file
		--kingdom	: the kingdom of the organism
		--organism	: the name of the searched organism	
		--strain	: the strain of the organism
		--replicon	: name of the replicon
		--word_max_length : max length of k-nucleotids that we count ( 1 <= k <= word_max_length)
		--win_min_length : min length of the window which moves about the genome to compute statistics 
		--win_max_length : max length of the window which moves about the genome to compute statistics  
		--step 		: additional size between two windows 
		--shift_size 	: shift of the moving window about the genome
END
}
	


=head2 procedure ComputeAShiftStat

 Title        : ComputeAShiftStat
 Usage        : ComputeAShiftStat($seq, $word_max_length, $win_dir_way, $win_length, $rh_file_desc)
 Prerequisite : none
 Function     : compute characteristics about a window of the genome ($seq) which has a length of $win_length
 		Update files containing in the hashtab rh_file_desc
 Returns      : none
 Args         : $seq : sequence of the window
 		$word_max_length : max length of k-nucleotids that we count ( 1 <= k <= word_max_length)
		$win_dir_way : way of the window directory
		$win_length : length of the window
		$rh_file_desc : reference about an hashtab of file descriptors
 Globals      : none

=cut 
sub ComputeAShiftStat
{
	my ($seq, $word_max_length, $win_dir_way, $win_length, $rh_file_desc) = @_;
	
	# 1 - compute the numbers of k-nucleotids in the sequence and update the corresponding files
	&ComputeAShiftSeqKNucl($seq,$word_max_length,$rh_file_desc);
	
	# 2 - compute the free energy, get the way of the create structure file and get the number of paired nucleotids
	my ($struct_file, $paired_nucl_nb) = &ComputeAShiftFreeEnergy($seq, $win_dir_way,$rh_file_desc->{$FE_FILE_NAME});
	
	# 3 - compute the number of paired nucleotids and update the file
	&ComputeAShiftTotalPairNb($paired_nucl_nb, $win_length, $rh_file_desc->{$PAIR_INFO_FILE_NAME});
	
	# 4 - compute the numbers of k-nucleotids for the paired nucleotids and update the files
	&ComputeAShiftStructKNucl($seq,$struct_file, $word_max_length, $win_dir_way,$rh_file_desc);

	# 5 - compute the numbers of paired nucleotids and update the files
	&ComputeAShiftPairNb($seq, $struct_file, $rh_file_desc);

	# delete the structure file
	&DeleteFile($struct_file);	
}

=head2 procedure ComputeAShiftSeqKNucl

 Title        : ComputeAShiftSeqKNucl
 Usage        : ComputeAShiftSeqKNucl($seq, $word_max_length, $rh_file_desc)
 Prerequisite : none
 Function     : compute k-nucleotid number (1 <= k <= $word_max_length) about the sequence 
		Update k-nucleotids files in rh_file_desc (add at the end of each file a new value) 
 Returns      : none
 Args         : $seq : sequence of the window (fasta file or nucleotidic sequence)
 		$word_max_length : max length of the k-nucleotids to count
		$rh_file_desc : reference about an hashtab of file descriptors
 Globals      : none

=cut 
sub ComputeAShiftSeqKNucl
{
	my ($seq, $word_max_length, $rh_file_desc) = @_;
	
	my $rh_knucl;		# reference of a hashtab containing the number of each k-nucleotid
	my $new_data;		# new value to add to the end of the file
	
	# for each k: 1<= k <= $word_max_length 
	for (my $length = 1 ; $length <= $word_max_length ; $length++ ) {
		# compute k-nucleotid numbers
		$rh_knucl = &ComputeKNucl($seq, $length);
		
		# for each k-nucleotid, update the corresponding file
		foreach my $knucl (keys(%{$rh_knucl})) {
			$new_data = $rh_knucl->{$knucl}."\n";
			&UpdateOpenedFile($rh_file_desc->{$knucl."_seq"}, $new_data);
		}
	}	
}


=head2 function ComputeAShiftFreeEnergy

 Title        : ComputeAShiftFreeEnergy
 Usage        : ComputeAShiftFreeEnergy($seq, $win_dir_way,$energy_file_desc)
 Prerequisite : none
 Function     : compute structure and free energy about the current window and 
 		about its inverse complement, with RNAfold.
		Update free energy file 
		Create the file "structure" in the directory $win_dir_way
 Returns      : the way of the created file, which contains the extracted structure of the window
 		and tne number of paired nucleotids
 Args         : $seq : sequence of the window
		$win_dir_way : way of the directory where create the structure file
		$energy_file_desc : desc of the file about free energy
 Globals      : none

=cut  
sub ComputeAShiftFreeEnergy
{
	my ($seq, $win_dir_way, $energy_file_desc) = @_; 
	
	my $struct_data		= "\n";
	my $struct_file_name	= &GetStructureFileName();
	
	# execute RNAFold
	chdir($win_dir_way);
	my ($free_energy, $struct) 		= &ComputeFreeEnergy($seq);
	
	# execute RNAFold with the inverse complement sequence
	my $compl_inv_seq 			= &reverse_complement_as_string($seq);
	my($free_energy_inv, $structure_inv) 	= &ComputeFreeEnergy($compl_inv_seq);
	
	#save data in the file
	my $free_energy_string 			= $free_energy." ".$free_energy_inv."\n";
	&UpdateOpenedFile($energy_file_desc, $free_energy_string);
	
	my $ra_paired_nucleotids= &ComputePairedNucleotids($struct);	# compute the pairs generated by RNAfold in an array
	my $paired_nucl_nb	= ($#$ra_paired_nucleotids+1)*2;	# compute the number of paired nucleotids
	
	# if RNAfold gets a structure, save it
	if ($paired_nucl_nb > 0) {
		$struct_data = &StructureToString($ra_paired_nucleotids); 
	}
	# create the structure file 
	&CreateFile($struct_file_name, $win_dir_way, $struct_data); 

	# return the way of the created structure file, and the number of paired nucleotids
	return ($win_dir_way.$struct_file_name, $paired_nucl_nb);
}

=head2 procedure ComputeAShiftTotalPairNb

 Title        : ComputeAShiftTotalPairNb
 Usage        : ComputeAShiftTotalPairNb($paired_nucl_nb, $win_length, $file_desc)
 Prerequisite : none
 Function     : compute the number of paired nucleotids and unpaired nucleotids
 		update the corresponding file $file_desc
 Returns      : none
 Args         : $paired_nucl_nb : number of paired nucleotids
 		$win_length : length of the window on the genomic sequence
		$file_desc : desc of the file about pair information 
 Globals      : none

=cut  
sub ComputeAShiftTotalPairNb
{
	my ($paired_nucl_nb, $win_length, $file_desc) = @_;
	
	# count the number of unpaired nucleotids
	my $unpaired_nucl_nb 	= $win_length - $paired_nucl_nb;
	my $data_string		= $paired_nucl_nb." ".$unpaired_nucl_nb."\n";
	
	# update the file PairInformation 
	&UpdateOpenedFile($file_desc, $data_string);
}


=head2 procedure ComputeAShiftStructKNucl

 Title        : ComputeAShiftStructKNucl
 Usage        : ComputeAShiftStructKNucl($seq, $struct_file, $word_max_length, $win_dir_way, $rh_file_desc)
 Prerequisite : none
 Function     : compute k-nucleotid numbers (1 <= k <= $word_max_length) about the paired subsequences 
 		of $seq
		Update k-nucleotids files (add at the end of each file a new value) 
 Returns      : none
 Args         : $seq : sequence of the window (fasta file or nucleotidic sequence)
 		$struct_file :  way of the file structure
 		$word_max_length : max length of the k-nucleotids to count (1 <= k <= $word_max_length)
		$win_dir_way : way of the directory where create the multifasta file for the structure
		$rh_file_desc : reference about an hashtab of file descriptors
 Globals      : none

=cut 
sub ComputeAShiftStructKNucl
{
	my ($seq, $struct_file, $word_max_length, $win_dir_way, $rh_file_desc) = @_;
	my $rh_knucl;
	my $new_data;	
	
	# extract the regions of the sequence which are paired
	my $regions = &ExtractStructureRegions($struct_file);
	
	if ($regions eq "") {
		my @a_knucl;
		my @a_alphabet = ('A','C','G','T');
		# compute each k-nucleotid name
		for (my $length = 1 ; $length <= $word_max_length ; $length++ ) {
			push(@a_knucl, &GetCombination($length,\@a_alphabet));
			push(@a_knucl, "Other$length");
		}
		# save 0 for each k-nucleotid
		for (my $i = 0 ; $i <= $#a_knucl ; $i++) {
			&UpdateOpenedFile($rh_file_desc->{$a_knucl[$i]."_struct"}, "0\n");
		}
	}else {
		
		# create a multifasta file composed of the extracted regions
		&CreateMultiFastaFile($seq, $regions, $MULTI_FASTA_FILE_NAME, $win_dir_way);
		my $multifasta_file_way = $win_dir_way.$MULTI_FASTA_FILE_NAME;
		
		for (my $length = 1 ; $length <= $word_max_length ; $length++ ) {
			$rh_knucl = &ComputeKNucl($multifasta_file_way, $length);
			# for each k-nucleotid, update the corresponding file
			foreach my $knucl (keys(%{$rh_knucl})) {
				$new_data = $rh_knucl->{$knucl}."\n";
				&UpdateOpenedFile($rh_file_desc->{$knucl."_struct"}, $new_data);
			}
		}
		# delete the multifasta file 
		&DeleteFile($multifasta_file_way);
	}
}		
		
=head2 procedure ComputeAShiftPairNb

 Title        : ComputeAShiftPairNb
 Usage        : ComputeAShiftPairNb($seq, $struct_file, $rh_file_desc)
 Prerequisite : none
 Function     : compute the numbers of pairs (A-U, U-A, G-C, C-G, G-U, U-G) in the sequence
		Update pair files (add at the end of each file a new value)
 Returns      : none
 Args         : $seq : sequence of the window (fasta file or nucleotidic sequence)
		$struct_file :  way of the file structure
		$rh_file_desc : reference about an hashtab of file descriptors
 Globals      : none

=cut 

sub ComputeAShiftPairNb
{
	my ($seq, $struct_file,$rh_file_desc) = @_;
	my $new_data; # new value to add to the end of the file
	
	# need to convert T's to U's to count the pairs
	$seq =~s/T/U/g;
	
	# get the number of each nucleotidic pair in a hashtable
	my $rh_pair_nb = &ComputePair($struct_file, $seq);
	
	# for each pairs, update the corresponding file
	foreach my $pair (keys(%{$rh_pair_nb})) {
		$new_data = $rh_pair_nb->{$pair}."\n";
		&UpdateOpenedFile($rh_file_desc->{$pair."_pair"}, $new_data);
	}	
}


#####################################################################################################
# Part Creation of directories and files
#####################################################################################################

=head2 procedure CreateBasicStatDirectory

 Title        : CreateBasicStatDirectory
 Usage        : CreateBasicStatDirectory($replicon_way, $bas_stat_dir_name)
 Prerequisite : none
 Function     : creates the directory $bas_stat_dir_name in the directory $replicon_way
 Returns      : none
 Args         : $replicon_way : way of the directory of the replicon
 		$bas_stat_dir_name : name of the basic characteristic directory
 Globals      : none
 
=cut
sub CreateBasicStatDirectory
{
	my ($replicon_way, $bas_stat_dir_name) = @_;
	# create directory which will contain the basic characteristics
	if ( !(&ExistDirectory($bas_stat_dir_name, $replicon_way)) ) {
		&CreateDirectory($bas_stat_dir_name, $replicon_way);
	}
}

=head2 procedure CreateWinDirectory

 Title        : CreateWinDirectory
 Usage        : CreateWinDirectory($replicon_way, $win_length, $shift_size)
 Prerequisite : none
 Function     : creates the directory win{$win_length}_shift{$shift_size}_stat
 		in the directory basic_statistics in the replicon directory
 Returns      : none
 Args         : $replicon_way : way of the directory of the replicon
 		$win_length : length of the window
                $shift_size : size of the shift of the window
 Globals      : none
 
=cut
sub CreateWinDirectory
{
	my ($replicon_way, $win_length, $shift_size) = @_;
	
	# directory of the characteristic files
	my $basic_stat_way = &GetBasicStatDir($replicon_way);
	
	# create the directory for windows which have the length $win_length
	my $win_dir_name = &getNameWinDir($win_length, $shift_size);
	if ( !(&ExistDirectory($win_dir_name, $basic_stat_way)) ) {
		&CreateDirectory($win_dir_name, $basic_stat_way);
	}
}


=head2 function CreateStatEmptyFiles

 Title        : CreateStatEmptyFiles
 Usage        : CreateStatEmptyFiles($output_dir,$win_length, $word_max_length)
 Prerequisite : none
 Function     : create the empty files which will contain characteristics about the window of length $win_length, 
 		in the directory $output_dir
 		- k-nucleotid number files for the sequence and for paired nucleotids 
		  (1<= k <= $word_max_length)
		- paired/unpaired nucleotid number 
		- nucleotid pair (A-U, U-A, G-C, C-G, U-G, G-U)
		- free energy
 Returns      : a reference about an hashtable containing file descriptors
 Args         : $output_dir : directory in which files will be created
		$win_length : length of the window
		$word_max_length : max length of the k-nucleotids to count
 Globals      : none
=cut 
sub CreateStatEmptyFiles
{
	my ($output_dir, $win_length, $word_max_length) = @_;
	my @a_knucleotid;	# set of k-nucleotid
	my $win_file_name;	# name of the file
	my %h_file_desc;
	my $file_desc;
	my @a_alphabet 	= &GetNucleotids();
	
	# compute each k-nucleotid word (if $word_max_length=2, push AA, AC, AG, AT, ...) 
	for (my $length = 1 ; $length <= $word_max_length ; $length++ ) {
		push(@a_knucleotid, &GetCombination($length,\@a_alphabet));
		push(@a_knucleotid, "Other$length");	
	}
	
	# for each found k-nucleotid, creation of a file for its number in the sequence 
	# and a file for its number in the structure 
	for (my $i = 0 ; $i <= $#a_knucleotid ; $i++) {
		$win_file_name  		= &GetKNucleotidFileName($a_knucleotid[$i],"seq");
		$file_desc 			= &CreateAndOpenFile($win_file_name, $output_dir);
		$h_file_desc{$win_file_name} 	= $file_desc;	# save the file desc in the hashtab
		$win_file_name 			= &GetKNucleotidFileName($a_knucleotid[$i],"struct");
		$file_desc 			= &CreateAndOpenFile($win_file_name, $output_dir);
		$h_file_desc{$win_file_name} 	= $file_desc;
	}
	
	# create free_energy file
	$file_desc 			= &CreateAndOpenFile($FE_FILE_NAME, $output_dir);
	$h_file_desc{$FE_FILE_NAME}	= $file_desc;
	
	
	# create pair_information file
	$file_desc 				= &CreateAndOpenFile($PAIR_INFO_FILE_NAME, $output_dir);
	$h_file_desc{$PAIR_INFO_FILE_NAME}	= $file_desc;
	
	
	# compute each possible pair
	my @a_pair = &GetRNAPair();
 	my $pair;
	
	for (my $i = 0 ; $i <= $#a_pair ; $i++) {
		# create pair number files
		$pair				= "$a_pair[$i][0]$a_pair[$i][1]";
		$win_file_name			= &GetKNucleotidFileName($pair, "pair");
		$file_desc 			= &CreateAndOpenFile($win_file_name, $output_dir);
		$h_file_desc{$win_file_name}	= $file_desc;
	
		$pair				= "$a_pair[$i][1]$a_pair[$i][0]";
		$win_file_name			= &GetKNucleotidFileName($pair, "pair");
		$file_desc 			= &CreateAndOpenFile($win_file_name, $output_dir);
		$h_file_desc{$win_file_name}	= $file_desc;
	}
	return \%h_file_desc;	
}

#####################################################################################################
# Part get Files and directories names
#####################################################################################################
 
=head2 function getNameWinDir

 Title        : getNameWinDir
 Usage        : getNameWinDir($win_length, $shift_size)
 Prerequisite : none
 Function     : compute and return the name of the directory which contains characteristics about 
 		windows with the size $win_length
 Returns      : the name of the directory which contains characteristics about windows with the size $win_length
 Args         : $win_length : length of the window
                $shift_size : size of the window shift
 Globals      : none
=cut 
sub getNameWinDir
{
	my ($win_length, $shift_size) = @_;
	my $name = "win".$win_length."_shift".$shift_size."_stat";
	return ($name);
}


=head2 function GetBasicStatDir

 Title        : GetBasicStatDir
 Usage        : GetBasicStatDir($replicon_way)
 Function     : return the way of the directory which contains the basic characteristics
 Returns      : the way of the directory which contains the basic characteristics
 Args         : $replicon_way : way of the directory of the replicon	
 Globals      : none

=cut
sub GetBasicStatDir
{
	my ($replicon_way) = @_;
	my $bas_stat_dir	= $replicon_way.$BASIC_STAT_DIR_NAME."/";
	return ($bas_stat_dir);
}

=head2 function GetWinDirWay

 Title        : GetWinDirWay
 Usage        : GetWinDirWay($replicon_way, $win_length, $shift_size)
 Function     : return the way of the directory which contains the basic characteristics about the window 
 		with length $win_length
 Returns      : the way of the directory which contains the basic characteristics about the window with length $win_length
 Args         : $replicon_way : way of the directory of the replicon
 		$win_length : length of the window	
                $shift_size : size of the window shift
 Globals      : none

=cut
sub GetWinDirWay
{
	my ($replicon_way,$win_length, $shift_size) = @_;
	my $win_dir_way =  &GetBasicStatDir($replicon_way).getNameWinDir($win_length, $shift_size)."/";
	return ($win_dir_way);
}
